'DTMF2SER2   Decodierung von TIPSEND2-Daten    getestet
'
'Eingaenge:
'4-Bit-Datenwort von Decoder MT8870 an Eingaenge PB0(LSB) bis PB3(MSB)
'Strobeausgang von Decoder MT8870 an INT0-Eingang PD2

$regfile = "m8def.dat"
$crystal = 8000000
$baud = 9600
$hwstack = 32
$swstack = 10
$framesize = 40

Dim Wt As Byte
Dim Dtmf As Byte
Dim Wert1 As Byte
Dim Wert2 As Byte
Dim Wert3 As Byte
Dim Wert4 As Byte
Dim Strg As String * 1

Declare Sub Indata
Declare Sub Waitchr
Declare Sub Flash

Config Portb = Input
Portb = &B11111111
Config Portc.1 = Output
Portc.1 = 0

Enable Interrupts
Enable Int0

'IRQ-Triggering durch pos.Flanke
Mcucr.0 = 1
Mcucr.1 = 1

On Int0 Isr1

Start:
'warte auf 1.Zeichen; empf. Charakter steht in "strg"
Gosub Waitchr
Gosub Indata
If Strg = "#" Then Goto Jump1
If Strg = "*" Then Goto Jump7
Goto Start

Jump1:
Gosub Flash
'warte auf 2.Zeichen wenn 1.Zeichen = "#"
Gosub Waitchr
Gosub Indata
If Strg = "0" Then Goto Jump2
If Strg = "9" Then Goto Jump3
If Strg = "#" Then Goto Jump4
Goto Start

Jump2:
Gosub Flash
Print Chr(63);                                              'send "?"
Goto Start

Jump3:
Gosub Flash
Print Chr(46);                                              'send "."
Goto Start

Jump4:
Gosub Flash
'warte auf 3.Zeichen wenn 2.Zeichen = "#"
Gosub Waitchr
Gosub Indata
If Strg = "#" Then Goto Jump5
If Strg = "*" Then Goto Jump6
If Strg = "0" Then Print Chr(32);
If Strg = "1" Then Print Chr(66);
If Strg = "2" Then Print Chr(69);
If Strg = "3" Then Print Chr(72);
If Strg = "4" Then Print Chr(75);
If Strg = "5" Then Print Chr(78);
If Strg = "6" Then Print Chr(81);
If Strg = "7" Then Print Chr(84);
If Strg = "8" Then Print Chr(87);
If Strg = "9" Then Print Chr(90);
Goto Start

Jump5:
Gosub Flash
'warte auf 4.Zeichen wenn 3.Zeichen = "#"
Gosub Waitchr
Gosub Indata
If Strg = "0" Then Print Chr(33);
If Strg = "1" Then Print Chr(67);
If Strg = "2" Then Print Chr(70);
If Strg = "3" Then Print Chr(73);
If Strg = "4" Then Print Chr(76);
If Strg = "5" Then Print Chr(79);
If Strg = "6" Then Print Chr(82);
If Strg = "7" Then Print Chr(85);
If Strg = "8" Then Print Chr(88);
Goto Start

Jump6:
Gosub Flash
'warte auf 4.Zeichen wenn 3.Zeichen = "*"
Gosub Waitchr
Gosub Indata
If Strg = "1" Then Print Chr(65);
If Strg = "2" Then Print Chr(68);
If Strg = "3" Then Print Chr(71);
If Strg = "4" Then Print Chr(74);
If Strg = "5" Then Print Chr(77);
If Strg = "6" Then Print Chr(80);
If Strg = "7" Then Print Chr(83);
If Strg = "8" Then Print Chr(86);
If Strg = "9" Then Print Chr(89);
Goto Start

Jump7:
Gosub Flash
'warte auf 2.Zeichen wenn 1.Zeichen = "*"
Gosub Waitchr
Gosub Indata
If Strg = "#" Then Goto Jump8
If Strg = "*" Then Goto Jump9
Goto Start

Jump8:
Gosub Flash
'warte auf 3.Zeichen wenn 2.Zeichen = "#"
Gosub Waitchr
Gosub Indata
If Strg = "0" Then Print Chr(48);
If Strg = "1" Then Print Chr(49);
If Strg = "2" Then Print Chr(50);
If Strg = "3" Then Print Chr(51);
If Strg = "4" Then Print Chr(52);
If Strg = "5" Then Print Chr(53);
If Strg = "6" Then Print Chr(54);
If Strg = "7" Then Print Chr(55);
If Strg = "8" Then Print Chr(56);
If Strg = "9" Then Print Chr(57);
Goto Start

Jump9:
Gosub Flash
'warte auf 3.Zeichen wenn 2.Zeichen = "*"
Gosub Waitchr
Gosub Indata
If Strg = "2" Then Print Chr(45);
If Strg = "8" Then Print Chr(44);
Goto Start

End

'---------------------------------
'Interruptausloesung nach DTMF-Tonerkennung

Isr1:
Wt = 0
Return

'-----------------------------------------
'LED-Flash an PD7

Flash:
Portc.1 = 1
Waitms 30
Portc.1 = 0
Return

'----------------------------------------
'Warten auf Strobe an IRQ0-Eingang "PD2"

Waitchr:
Wt = 1
Do
Loop Until Wt = 0
Wt = 1
Return

'---------------------------------
'Abfrage von DTMF-Bitmuster an PB0-PB3

Sub Indata
If Pinb.0 = 1 Then Wert1 = 1 Else Wert1 = 0
If Pinb.1 = 1 Then Wert2 = 2 Else Wert2 = 0
If Pinb.2 = 1 Then Wert3 = 4 Else Wert3 = 0
If Pinb.3 = 1 Then Wert4 = 8 Else Wert4 = 0

Dtmf = Wert1 + Wert2
Dtmf = Dtmf + Wert3
Dtmf = Dtmf + Wert4

If Dtmf = 0 Then Strg = "D"
If Dtmf = 1 Then Strg = "1"
If Dtmf = 2 Then Strg = "2"
If Dtmf = 3 Then Strg = "3"
If Dtmf = 4 Then Strg = "4"
If Dtmf = 5 Then Strg = "5"
If Dtmf = 6 Then Strg = "6"
If Dtmf = 7 Then Strg = "7"
If Dtmf = 8 Then Strg = "8"
If Dtmf = 9 Then Strg = "9"
If Dtmf = 10 Then Strg = "0"
If Dtmf = 11 Then Strg = "*"
If Dtmf = 12 Then Strg = "#"
If Dtmf = 13 Then Strg = "A"
If Dtmf = 14 Then Strg = "B"
If Dtmf = 15 Then Strg = "C"
End Sub